fn main() {
    let input = std::fs::read_to_string("input.txt").unwrap();

    let result = calibration_value(&input);

    println!("Result: {}", result);
}

fn calibration_value(input: &str) -> u32 {
    input.lines()
        .map(|line| {
            let digits: Vec<char> = line.chars().filter(|c| c.is_numeric()).collect();

            let first = digits.first().unwrap().to_digit(10).unwrap();
            let last = digits.last().unwrap().to_digit(10).unwrap();
            dbg!(first * 10 + last)
        })
        .sum()
}


#[cfg(test)]
mod tests {
    use crate::calibration_value;

    const EXAMPLE: &str = "1abc2\npqr3stu8vwx\na1b2c3d4e5f\ntreb7uchet";

    #[test]
    fn example() {
        let result = calibration_value(EXAMPLE);
        assert_eq!(142, result);
    }
}